
! Preprocessor flags for IBM-specific tunings
! Version @(#)ibm.h	1.3 10/21/97

#ifdef IBM_POWER2_WIDE
! Special tuning for the IBM POWER2, wide-nodes (256-bit memory bus)
! Recommended XLF compiler flags:
! -qarch=pwr2 -O3 -qhot -qfloat=hssngl
#define IBM
#endif

#ifdef IBM_POWER2_THIN
! Special tuning for the IBM POWER2, thin/thin2-nodes (64/128-bit memory bus)
! Recommended XLF compiler flags:
! -qarch=pwr2 -qtune=pwr2s -O3 -qhot -qfloat=hssngl
#define IBM
#endif

#ifdef IBM_POWER
! Special tuning for the IBM POWER CPUs
! Recommended XLF compiler flags:
! -qarch=pwr -O3 -qhot -qfloat=hssngl
#define IBM
#endif

#ifdef IBM_PPC
! Special tuning for the IBM PowerPC CPUs
! Recommended XLF compiler flags:
! -qarch=ppc -O3 -qhot -qfloat=hssngl
#define IBM
#endif

#ifdef IBM
! Assume that ALL IBM computers have the IBM ESSL library installed.
! Do not panic !  Buying ESSL is cheap and gets excellent performance
! out of your code.  /OHN, 13-Sep-1996.
! #define ESSL
#endif

#ifdef ESSL
! IBM ESSL has the BLAS subroutines included
#define BLAS
#endif
